﻿#!/usr/bin/env python3
#!/usr/bin/env python3
# -*- coding:utf-8 -*-
#-------------------------------------------------------------------------------
# Name:        NMEAextractionFromUbloxLog
# Purpose:      ubloxのバイナリデータを含むデータからNMEAセンテンスのみを抽出する
#
# Author:      morishita
#
# Created:     28/03/2012
# Copyright:   (c) morishita 2012
# Licence:     new BSD
#-------------------------------------------------------------------------------
#!/usr/bin/env python

import sys
import ubloxParser

def main():
    argvs = sys.argv  # コマンドライン引数を格納したリストの取得
    argc = len(argvs) # 引数の個数
    # デバッグプリント
    #print(argvs)
    #print(argc)
    if (argc != 2):                                         # 引数が足りない場合は、その旨を表示
        print('Usage: # python %s filename' % argvs[0])     # 0はスクリプトファイル自体を指す
        quit()                                              # プログラムの終了
    fname = argvs[1]
    #fname = "20120202_movingStation.ubx"
    fr = open(fname,"rb")                                   # バイナリモードでファイルを開く
    data = fr.read()                                        # バイナリデータをbytes型変数に格納
    fr.close()
    txt = data.decode("ascii", errors='replace')            # バイナリコードを文字列化する。ubloxのデータにはASCII以外のデータが含まれるのでエラー対策が必要。replaceでエラーが出ても無視して文字を置換させる。ignoreではなくreplaceを使うのは、文字の位置を変えないため。
    _NMEAtxt = ubloxParser.extractNMEAfromText(txt)         # NMEAを抽出（リストとなる）
    fw = open("extractedNMEA.nme", "w")
    fw.write(_NMEAtxt)                                      # リストを文字列として結合させて出力する
    fw.close()

if __name__ == '__main__':
    main()
